CUDNN Frontend API 8.3.0

Classes | Public Member Functions | Private Member Functions | Private Attributes | Friends | List of all members
cudnn_frontend::Engine_v8 Class Reference

`#include <cudnn_frontend_Engine.h>`

Inheritance diagram for cudnn_frontend::Engine_v8:
Collaboration diagram for cudnn_frontend::Engine_v8:

## Classes
class | Knob

## Public Member Functions
std::string | describe () const override
| Return a string describing the backend Descriptor. More...
| Engine_v8 (Engine_v8 &&from)
Engine_v8 & | operator= (Engine_v8 &&)=default
| ~Engine_v8 ()=default
std::string const & | getTag () const
std::vector< Knob > & | getSupportedKnobs ()
| Returns a vector of knobs to the user for modification. More...
std::vector< Knob > const & | getFinalizedKnobs () const
| Returns a final vector of knobs. Used in EngineConfigBuilder. More...
bool | knobs_set () const
Public Member Functions inherited from cudnn_frontend::BackendDescriptor
cudnnBackendDescriptor_t | get_raw_desc () const
cudnnStatus_t | get_status () const
| Current status of the descriptor. More...
void | set_status (cudnnStatus_t const status_) const
| Set status of the descriptor. More...
void | set_error (const char *message) const
| Set Diagonistic error message. More...
const char * | get_error () const
| Diagonistic error message if any. More...
ManagedOpaqueDescriptor | get_desc () const
| Returns a copy of underlying managed descriptor. More...
cudnnStatus_t | initialize_managed_backend_pointer (cudnnBackendDescriptorType_t type)
| Initializes the underlying managed descriptor. More...

## Private Member Functions
| Engine_v8 ()=default
| Engine_v8 (Engine_v8 const &)=delete
Engine_v8 & | operator= (Engine_v8 const &)=delete
void | buildKnobs ()
| Called from the constructor builds the internal knobs vector. More...

## Private Attributes
ManagedOpaqueDescriptor | opGraph = nullptr
int64_t | idx = -1
| Global Index of the engine for the given operationGraph. More...
int64_t | numKnobs = 0
| Count of the backend knobs in the engine. More...
std::array< ManagedOpaqueDescriptor, CUDNN_KNOB_TYPE_COUNTS > | bKnobs = {}
| Opaque pointer to the backend knobs. More...
std::vector< Knob > | knobs
std::string | opGraphTag

## Friends
class | EngineBuilder_v8

## Additional Inherited Members
Protected Member Functions inherited from cudnn_frontend::BackendDescriptor
| BackendDescriptor (ManagedOpaqueDescriptor pointer_, cudnnStatus_t status_, std::string err_msg_)
| BackendDescriptor ()=default
Protected Attributes inherited from cudnn_frontend::BackendDescriptor
ManagedOpaqueDescriptor | pointer
cudnnStatus_t | status = CUDNN_STATUS_SUCCESS
| Shared pointer of the OpaqueBackendPointer. More...
std::string | err_msg
| Error message if any being set. More...

## Detailed Description

Engine_v8 Class This class tells the properties of the Engine_v8 on which performs the operation requested Properties:

- Index
- OperationGraph_v8

Use EngineBuilder_v8 to build this class. Describe returns a string describing the tensor class

Definition at line 52 of file cudnn_frontend_Engine.h.

## Constructor & Destructor Documentation

## ◆ Engine_v8() [1/3]

cudnn_frontend::Engine_v8::Engine_v8 | ( |  | ) |
| privatedefault

## ◆ Engine_v8() [2/3]

cudnn_frontend::Engine_v8::Engine_v8 | ( | Engine_v8 const & |  | ) |
| privatedelete

## ◆ Engine_v8() [3/3]

cudnn_frontend::Engine_v8::Engine_v8 | ( | Engine_v8 && | from | ) |
| inline

< Opaque pointer to the backend knobs

Definition at line 174 of file cudnn_frontend_Engine.h.

References buildKnobs(), cudnn_frontend::make_shared_backend_pointer(), numKnobs, operator=(), cudnn_frontend::BackendDescriptor::pointer, cudnn_frontend::set_error_and_throw_exception(), cudnn_frontend::BackendDescriptor::status, and ~Engine_v8().

## ◆ ~Engine_v8()

cudnn_frontend::Engine_v8::~Engine_v8 | ( |  | ) |
| default

Referenced by Engine_v8().

## Member Function Documentation

## ◆ buildKnobs()

void cudnn_frontend::Engine_v8::buildKnobs | ( |  | ) |
| inlineprivate

Called from the constructor builds the internal knobs vector.

Definition at line 122 of file cudnn_frontend_Engine.h.

References cudnn_frontend::Engine_v8::Knob::Knob(), cudnn_frontend::Engine_v8::Knob::maxValue, cudnn_frontend::Engine_v8::Knob::minValue, numKnobs, cudnn_frontend::set_error_and_throw_exception(), cudnn_frontend::BackendDescriptor::status, and cudnn_frontend::Engine_v8::Knob::stride.

Referenced by Engine_v8().

## ◆ describe()

std::string cudnn_frontend::Engine_v8::describe | ( |  | ) | const
| inlineoverridevirtual

Return a string describing the backend Descriptor.

Implements cudnn_frontend::BackendDescriptor.

Definition at line 167 of file cudnn_frontend_Engine.h.

References idx.

## ◆ getFinalizedKnobs()

std::vector<Knob> const& cudnn_frontend::Engine_v8::getFinalizedKnobs | ( |  | ) | const
| inline

Returns a final vector of knobs. Used in EngineConfigBuilder.

Definition at line 225 of file cudnn_frontend_Engine.h.

References knobs.

## ◆ getSupportedKnobs()

std::vector<Knob>& cudnn_frontend::Engine_v8::getSupportedKnobs | ( |  | ) |
| inline

Returns a vector of knobs to the user for modification.

Definition at line 219 of file cudnn_frontend_Engine.h.

References knobs.

## ◆ getTag()

std::string const& cudnn_frontend::Engine_v8::getTag | ( |  | ) | const
| inline

Definition at line 213 of file cudnn_frontend_Engine.h.

References opGraphTag.

## ◆ knobs_set()

bool cudnn_frontend::Engine_v8::knobs_set | ( |  | ) | const
| inline

Definition at line 229 of file cudnn_frontend_Engine.h.

References cudnn_frontend::Engine_v8::Knob::getChoice(), and numKnobs.

## ◆ operator=() [1/2]

Engine_v8& cudnn_frontend::Engine_v8::operator= | ( | Engine_v8 const & |  | ) |
| privatedelete

Referenced by cudnn_frontend::EngineBuilder_v8::build(), and Engine_v8().

## ◆ operator=() [2/2]

Engine_v8& cudnn_frontend::Engine_v8::operator= | ( | Engine_v8 && |  | ) |
| default

## Friends And Related Function Documentation

## ◆ EngineBuilder_v8

friend class EngineBuilder_v8
| friend

Definition at line 165 of file cudnn_frontend_Engine.h.

Referenced by cudnn_frontend::EngineBuilder_v8::build().

## Member Data Documentation

## ◆ bKnobs

std::array<ManagedOpaqueDescriptor, CUDNN_KNOB_TYPE_COUNTS> cudnn_frontend::Engine_v8::bKnobs = {}
| private

Opaque pointer to the backend knobs.

Definition at line 116 of file cudnn_frontend_Engine.h.

## ◆ idx

int64_t cudnn_frontend::Engine_v8::idx = -1
| private

Global Index of the engine for the given operationGraph.

Definition at line 114 of file cudnn_frontend_Engine.h.

Referenced by describe().

## ◆ knobs

std::vector<Knob> cudnn_frontend::Engine_v8::knobs
| private

Definition at line 117 of file cudnn_frontend_Engine.h.

Referenced by getFinalizedKnobs(), and getSupportedKnobs().

## ◆ numKnobs

int64_t cudnn_frontend::Engine_v8::numKnobs = 0
| private

Count of the backend knobs in the engine.

Definition at line 115 of file cudnn_frontend_Engine.h.

Referenced by buildKnobs(), Engine_v8(), and knobs_set().

## ◆ opGraph

ManagedOpaqueDescriptor cudnn_frontend::Engine_v8::opGraph = nullptr
| private

Definition at line 113 of file cudnn_frontend_Engine.h.

## ◆ opGraphTag

std::string cudnn_frontend::Engine_v8::opGraphTag
| private

Definition at line 118 of file cudnn_frontend_Engine.h.

Referenced by getTag().

The documentation for this class was generated from the following file:

- cudnn_frontend_Engine.h